Rem
	Testproject: Slidewars
EndRem

SuperStrict
	
'Screen______________________
Global gWidth:Int=800, gHeight:Int=600, gMode:Int=0
'____________________________

'States______________________
Const cEND:Int=0, cMENU:Int=1, cGAME:Int=2, cOVER:Int=3
Global gState:Int=cMENU

Global gTimer:TTimer = CreateTimer(60)
Global shotList:TList = New TList
SeedRnd MilliSecs()
'____________________________

Graphics gWidth, gHeight, gMode

'Images______________________
SetMaskColor($00, $00, $00)
Global imgItem:TImage = LoadAnimImage("item.png",16, 16, 0, 4, MASKEDIMAGE)
	MidHandleImage(imgItem)
Global imgEnemy:TImage = LoadImage("enemy.png", MASKEDIMAGE)
	MidHandleImage(imgEnemy)
Global imgShot:TImage = LoadAnimImage("shot.png",8,8,0,2,MASKEDIMAGE)
	MidHandleImage(imgShot)
'____________________________

'TYPES_______________________
Type TPlayer
	
	Global value:Int
	Global playerList:TList = CreateList()
	Const strenght:Int = 10
	Const shotupd:Int = 200
	
	Field _id:Int
	
	Field _imgShip:TImage
	Field _imgShield:TImage
	
	Field _x:Int, _y:Int
	
	Field _health:Int
	Field _shield:Float
	
	Field _strenght:Int
	Field _strenghtTime:Int
	
	Field _points:Int
	
	Field _shotTime:Int
	Field _shotFXTime:Int
	Field _shotUpd:Int
	
	Method New()
		value = value + 1
		_id = value
		
		playerList.AddLast(Self)
		
		SetMaskColor(0,0,0)
		_imgShip=LoadImage("player" +_id+ ".png", MASKEDIMAGE)
			MidHandleImage(_imgShip)
		_imgShield=LoadImage("shield.png", MASKEDIMAGE)
			MidHandleImage(_imgShield)
			
		_x=gWidth/2
		_y=gHeight-50
		
		_health=100
		_shield=50
		
		_strenght=strenght		
		
		_shottime = MilliSecs()
		_shotUpd = shotUpd
	End Method
	
	Method Draw()
		If (_health > 0)
			SetBlend(ALPHABLEND)
			SetAlpha(_shield/100)
			DrawImage _imgShield, _x, _y
			
			SetBlend(MASKBLEND)
			SetAlpha(1)
			DrawImage _imgShip, _x, _y
			
			SetColor($ff, $00, $00)
				DrawRect(_x-16, _y+16, Float(_health)/100*32, 2)
			SetColor($ff, $ff, $ff)
			
			'DrawText Float(_shield/100), _x-4, _y-25
		EndIf
	End Method
	
	Method Update()
		If (_health > 0) Then
			If (_strenght > strenght) Then
				If (MilliSecs()>_strenghtTime+10000) Then
					_strenght = strenght
				EndIf
			EndIf
			If (_shotUpd < shotUpd) Then
				If (MilliSecs()>_shotFXTime+10000) Then
					_shotUpd = shotUpd
				EndIf
			EndIf
			
			For Local s:Tshot = EachIn TShot.shotList
				
				If (s._own = -1) Then
					If (_shield > 0) Then
						If ImagesCollide(_imgShield, _x, _y, 0, imgShot, s._x, s._y, s._frame) Then
							_shield = _shield - s._damage
							s.Free()
						EndIf
					Else
						_shield = 0
						If ImagesCollide(_imgShip, _x, _y, 0, imgShot, s._x, s._y, s._frame) Then
							_health = _health - s._damage
							If (_health <= 0) Then Free()
							s.Free()
						EndIf
					EndIf
				EndIf
			Next
		EndIf
	End Method
	
	Method Move(dir_x:Int=0, dir_y:Int=0)
		If (_health > 0) Then
			If (_x>0) And (_x<gWidth) Then
				_x=_x+dir_x*10
			Else
				If (_x<=0) Then _x = 1
				If (_x>=gWidth) Then _x = (gWidth-1)
			EndIf
			
			If (_y>(gHeight/2)) And (_y<gHeight) Then
				_y=_y+dir_y*5
			Else
				If (_y<=(gHeight/2)) Then _y=(gHeight/2)+1
				If (_y>=gHeight) Then _y=gHeight-1
			EndIf
		EndIf
	End Method
	
	Method Shot()
		If (_health > 0)
			If (MilliSecs() > _shottime+_shotupd) Then
				Local s:TShot = New Tshot
				s.Create(_id, _x,_y-15, 10, _strenght)
				_shottime = MilliSecs()
			EndIf
		EndIf
	End Method
	
	Method Free()
		_x = -100
		value = value - 1
	End Method
	
	Method Remove()
		_imgShip=Null
		_imgShield=Null
		playerList.Remove(Self)		
	End Method
End Type

Type TEnemy
	Global enemyList:TList = CreateList()
	Const shotUpd:Int = 500
	
	Field _x:Int, _y:Int
	Field _moveX:Int, _moveY:Int
	
	Field _health:Int
	Field _damage:Int
	Field _destroy:Int
	
	Field _shotTime:Int
	Field _shotUpd:Int
	
	Method New()
		enemyList.AddLast(Self)
		
		_x = Rand(gWidth)
		_y = -20
		
		Local i:Int = Rand(0,6)
		If (i<3)
			_moveX = -1
		ElseIf (i>3)
			_moveX = 1
		Else
			_moveX = 0
		EndIf
		_moveY = 1
		
		_health = 50
		_damage = 5
		
		_shotTime = MilliSecs()
	End Method
	
	Method Move()
		
		_x = _x + _moveX
		_y = _y + _moveY
		
		If (_x = 0) Or (_x = (gWidth-1)) Then
			_moveX = _moveX*-1
		EndIf
		
		If (_y > (gHeight+20)) Then _y = -20
		
		If (_health <= 0) Then Free()
	End Method
	
	Method Draw()
		DrawImage(imgEnemy, _x, _y)
		SetColor($ff, $00, $00)
			DrawRect(_x-16, _y-16, Float(_health)/50*32, 2)
		SetColor($ff, $ff, $ff)
	End Method
	
	Method Shot()
		If (MilliSecs() > _shotTime+shotUpd) Then
			Local s:TShot = New Tshot
			s.Create(-1, _x,_y+15, -10, _damage)
			_shotTime = MilliSecs()
		EndIf
	End Method
		
	Method Free()
		For Local p:TPlayer = EachIn TPlayer.playerList
			If (_destroy = p._id) Then
				If (_moveX <> 3) Then
					p._points = p._points + 100
				Else
					p._points = p._points + 50
				EndIf
			EndIf
		Next
		
		For Local i:Int=0 To 2
			Local e:TExpl = New TExpl
			e.Create(_x+Rand(-10,10), _y+Rand(-10,10), i*100)
			enemyList.Remove(Self)
		Next
	End Method
	
	Method Remove()
		enemyList.Remove(Self)
	End Method
End Type

Type TShot
	Global shotList:TList = CreateList()
	
	Field _x:Int, _y:Int
	Field _frame:Int
	Field _steps:Int
	Field _own:Int
	Field _damage:Int
	
	Method New()
		shotList.AddLast(Self)
	End Method
	
	Method Create(id:Int, x:Int, y:Int, steps:Int, damage:Int)	
		_x = x
		_y = y
		_steps = -steps
		_own = id
		_damage = damage
		If (_damage > 10) Then
			_frame = 1
		Else
			_frame = 0
		EndIf
	End Method
	
	Method Move()
		_y=_y+_steps
		If (_y < -5) Or (_y > gHeight+5) Then Free()
	End Method
	
	Method Draw()
		If (_own = -1) Then
			SetColor($ff, $00, $00)
		Else
			SetColor($ff, $ff, $00)
		EndIf
		If (_steps > 0) Then SetRotation(180)
		DrawImage imgShot, _x, _y, _frame
		SetRotation(0)
	End Method
	
	Method Free()
		shotList.remove(Self)
	End Method
	
	Method Remove()
		shotList.remove(Self)
	End Method
End Type

Type TStar
	Global starList:TList = CreateList()
	
	Field _x:Int, _y:Int
	Field _col:Int
	
	Method New()
		starList.AddLast(Self)
	End Method
	
	Method Create(x:Int, y:Int=0)
		_x = x
		_y = y
		_col = Rand(64,192)
	End Method
	
	Method Move()
		_y = _y + 2
	End Method
	
	Method Draw()
		SetColor(_col, _col, _col)
		DrawRect _x, _y, 1, 1
		SetColor($ff, $ff, $ff)
	End Method
	
	Method Free()
		starList.remove(Self)
		Local s:TStar = New TStar
		s.Create(Rand(0,gWidth),0)
	End Method
	
	Method Remove()
		starList.remove(Self)
	End Method
End Type

Type TItem
	
	Global itemList:TList = CreateList()
	
	Field _x:Int, _y:Int
	Field _id:Int
	Field _frame:Int
	
	Method New()
		itemList.AddLast(Self)
		_frame = Rand(0,3)
		_x = Rand(5,gWidth-5)
		_y = 0
	End Method
	
	Method Move()
		_y = _y + 5
		If _y > gHeight+10 Then Free()
	End Method
	
	Method Draw()
		SetColor($ff,$ff,$ff)
		DrawImage imgItem, _x, _y, _frame
	End Method
	
	Method Free()
		itemList.Remove(Self)
	End Method
	
	Method Remove()
		itemList.Remove(Self)
	End Method
End Type

Type TExpl
	
	Global explList:TList = CreateList()
	
	Field _x:Int, _y:Int
	Field _scale:Float, _alpha:Float
	Field _cr:Int, _cg:Int
	Field _time:Int, _wait:Int
	
	Method New()
		explList.AddLast(Self)
		_alpha = 1
		_scale = Rand(3,5)
		_cr = 255
		_cg = 255
	End Method
	
	Method Create(x:Int, y:Int, wait:Int)
		_x = x
		_y = y
		_wait = wait
		_time = MilliSecs()
	End Method
	
	Method Update()
		If (MilliSecs()>_time+_wait)
			_alpha = _alpha - 0.025
			_cr = _cr -5
			_cg = _cg -15
			_scale = _scale + Rnd(.5, 1)
			draw()
		EndIf
	End Method
	
	Method Draw()
		SetBlend(ALPHABLEND)
		SetAlpha(_alpha)
		SetColor(_cr, _cg, $00)
		DrawOval(_x-_scale, _y-_scale, _scale*2, _scale*2)
		SetColor($ff, $ff, $ff)
		SetAlpha(1)
		SetBlend(MASKBLEND)
		If (_alpha<=0) Then Free()
	End Method
	
	Method Free()
		explList.Remove(Self)
	End Method
	
	Method Remove()
		explList.Remove(Self)
	End Method
End Type
'____________________________
HideMouse
Global pl1:TPlayer
Global pl2:TPlayer
'MAINLOOP________________________________________
'________________________________________________
While (gState<>cEND)

	Select gState
		Case cMENU
			Menu()
		Case cGAME
			Game()
		Case cOVER
			Over()
	End Select
	
	FlushKeys()
Wend
'________________________________________________
'________________________________________________
End
'FUNCTIONS_______________________________________
'________________________________________________

'MENU________________________
Function Menu()
	Local tState:Int=gState
	
	While (tState=gState)
	
		'Input
		Local kh_esc:Int=KeyHit(KEY_ESCAPE)
		Local kh_ret:Int=KeyHit(KEY_RETURN)
		
		'Proceed
		If kh_esc Then gState=cEND
		If kh_ret Then gState=cGAME
		
		'Output
		SetColor($ff, $ff, $ff)
		
		Local info:String = "Zum starten ENTER druecken"
		Local length:Int = TextWidth(info)*2
		Local height:Int = TextHeight(info)*2
		SetScale(2,2)
		DrawText(info, ((gWidth/2)-(length/2)), ((gHeight/2)-(height/2)))
		SetScale(1,1)
	
		info = "ESCAPE zum Beenden"
		length = TextWidth(info)
		height = TextHeight(info)
		DrawText(info, ((gWidth/2)-(length/2)), (gHeight-100))
	
		Flip
		Cls
	Wend
End Function
'____________________________

'GAME________________________
Function Game()
	
	Local tState:Int=gState
	
	pl1=New TPlayer
	pl2=New TPlayer
	
	Local spawnTime:Int = MilliSecs()
	Local spawnDelay:Int = 2000
	
	For Local i:Int=0 To 99
		Local s:TStar = New TStar
		s.Create(Rand(0,gWidth),Rand(0,gHeight))
	Next

	While (tState=gState)
		
		'Quit
		Local kh_esc:Int=KeyHit(KEY_ESCAPE)

		'Player_1
		Local kd_left:Int = KeyDown(KEY_LEFT)
		Local kd_right:Int = KeyDown(KEY_RIGHT)
		Local kd_up:Int = KeyDown(KEY_UP)
		Local kd_down:Int = KeyDown(KEY_DOWN)
		
		'PLayer_2
		Local kd_w:Int = KeyDown(KEY_W)
		Local kd_s:Int = KeyDown(KEY_S)
		Local kd_a:Int = KeyDown(KEY_A)
		Local kd_d:Int = KeyDown(KEY_D)
		
		'Proceed
		If kh_esc Then gState=cEND
		If pl1.value = 0 Then gState=cOVER
			
		pl1.Move(-kd_left Or kd_right, -kd_up Or kd_down)
		pl2.Move(-kd_a Or kd_d, -kd_w Or kd_s)
		
		Local itemSpawn:Int = Rand(500)
		If itemSpawn=1 Then Local i:TItem = New TItem
		
		If (MilliSecs()>spawnTime+spawnDelay) Then
			Local e:TEnemy = New TEnemy
			If (spawnDelay > 500) Then
				spawnDelay = spawnDelay - 5
			EndIf
			spawnTime = MilliSecs()
		EndIf
		
		For Local s:TStar = EachIn TStar.starList
			s.Move()
			s.Draw()
			If (s._y>gHeight) Then s.Free()
		Next
		
		For Local e:TEnemy = EachIn TEnemy.enemyList
			e.Move()
			e.Draw()
			
			For Local s:TShot = EachIn TShot.shotList
				If ImagesCollide(imgEnemy,e._x,e._y,0,imgShot,s._x,s._y,s._frame) And (s._own>0) Then
					e._health = e._health - s._damage
					e._destroy = s._own
					s.Free()
				EndIf
			Next
			
			For Local p:TPlayer = EachIn TPlayer.playerList
				If (Abs(e._x-p._x) < 10) Then e.Shot()
			Next
		Next
		
		For Local e:TExpl = EachIn TExpl.explList
			e.Update()
		Next
		
		For Local p:TPlayer = EachIn TPlayer.playerList
			p.Shot()
			p.Update()
			p.Draw()
		Next
		
		For Local s:TShot = EachIn TShot.shotList
			s.Move()
			s.Draw()
			If (s._y<0) Then s.Free()
		Next
		
		For Local i:TItem = EachIn TItem.itemList
			i.Move()
			i.Draw()
			For Local p:TPlayer = EachIn TPlayer.playerList
				If (p._health >0)
					If ImagesCollide(p._imgShip, p._x, p._y, 0, imgItem, i._x, i._y, i._frame) Then
						Select i._frame
							Case 0
								p._shotUpd = 100
								p._shotFXTime = MilliSecs()
							Case 1
								If p._strenght=p.strenght Then
									p._strenght=p._strenght*2
								EndIf
								p._strenghtTime=MilliSecs()
							Case 2
								p._points = p._points + 500
							Case 3
								p._shield=100
						End Select
						i.Free()
					EndIf
				EndIf
			Next
		Next
		
		'Output
		SetColor($ff, $ff, $ff)
		
		SetColor($ff, $00, $00)
		DrawText ("Spieler 1", 5, 5)
		
		SetColor($00, $00, $ff)
		DrawText ("Spieler 2", gWidth-100, 5)
		
		SetColor($ff, $ff, $00)
		DrawText(RSet(pl1._points, 9), 5, 20)
		DrawText(RSet(pl2._points, 9), gWidth-100, 20)
		
		Flip 0
		Cls
		WaitTimer(gTimer)
	
	Wend
End Function
'____________________________

'GAME_OVER___________________
Function OVER()
	Local tState:Int=gState
	
	Local winner:Int
	
	While (tState=gState)
		
		'Input
		Local kh_esc:Int=KeyHit(KEY_ESCAPE)
		
		'Proceed
		If kh_esc Then gState=cMENU
		
		If (pl1._points > pl2._points) Then
			winner = 1
		ElseIf (pl1._points < pl2._points)
			winner = 2
		Else
			winner = 0
		EndIf
		
		'Output
		SetColor($ff, $ff, $ff)
		Local info:String = "Game Over"
		Local lenght:Int = TextWidth(info)*4
		Local height:Int = TextHeight(info)*4
		SetScale(4,4)
		DrawText("Game Over", (gWidth/2)-(lenght/2), (gHeight/2)-(height/2))
		SetScale(1,1)
		
		SetColor($ff, $00, $00)
		DrawText ("Spieler 1", 5, 5)
		
		SetColor($00, $00, $ff)
		DrawText ("Spieler 2", gWidth-100, 5)
		
		SetColor($ff, $ff, $00)
		DrawText(RSet(pl1._points, 9), 5, 20)
		DrawText(RSet(pl2._points, 9), gWidth-100, 20)
		
		If winner Then
			info = "Gewinner: Spieler " + winner
		Else
			info = "Unentschieden"
		EndIf
		
		lenght = TextWidth(info)*2
		height = TextHeight(info)*2
		
		SetScale(2,2)
		DrawText(info, (gWidth/2)-(lenght/2), gHeight-100)
		SetScale(1,1)
		Flip
		Cls
	Wend
	
	For Local i:TPlayer = EachIn TPlayer.playerList
		i.Remove()
	Next
	
	For Local i:TEnemy = EachIn TEnemy.enemyList
		i.Remove()
	Next
	
	For Local i:TShot = EachIn TShot.shotList
		i.Remove()
	Next
	
	For Local i:TStar = EachIn TStar.starList
		i.Remove()
	Next
	
	For Local i:TItem = EachIn TItem.itemList
		i.Remove()
	Next
	
	For Local i:TExpl = EachIn TExpl.explList
		i.Remove()
	Next
End Function
'____________________________
