'* Globals
AppTitle = "JAA - Just Another Asteroids"
Global width = 1024	
Global height = 768
SeedRnd MilliSecs()

'*
'* Load Sound
'*
Global sfxShoot = LoadSound_ ("shoot3.wav")

Global sfxExplode:TList = CreateList_()
Global MaxExplodeSounds = 5

Global sfxItem = LoadSound_("powerup1.wav")

Global sfxHit = LoadSound_("hit1.wav"),i 'Sparmanahmen: Vermeide Redundanzen!
For i=1 To 6
	AddFirst_ sfxExplode,LoadSound_("explode"+i+".wav")
Next


'*
'* Line
'*
Type Line 
	Field x1, y1, x2, y2
	
	Function Create_:Line( x1, y1, x2, y2 )
		Local l:Line = New Line
		l.x1 = x1
		l.y1 = y1
		l.x2 = x2
		l.y2 = y2
		Return l
	EndFunction
End Type 

'*
'* Projektil
'*
Type projektil
	Field x,y,angle
	Field dx#, dy#
	Field oldx, oldy
	Field lx, ly
	Field speed#
	Field r,g,b
	Field id '* 0 = enemy,  1 = P1 , 2 = P2, 3 = Partikel
	'*
	'* Konstruktor
	'*
	Function Create_:Projektil( x, y, angle, speed#, r, g, b, id )
		Local pro:Projektil = New Projektil
		
		pro.oldx = x
		pro.oldy = y
		pro.lx = x
		pro.ly = y
		pro.x = x
		pro.y = y
		pro.angle = angle
		pro.speed = speed
		pro.dx = Cos_(angle)*speed
		pro.dy = Sin_(angle)*speed
		pro.r = r
		pro.g = g
		pro.b = b
		pro.id = id
		Return pro
	EndFunction
	
	'*
	'* Update
	'*
	Method update()
	
		x = x + dx
		y = y + dy
		lx = lx + dx
		ly = ly + dy
		
		If( x > width ) Then  x = 0
		If( x < 0 ) Then x = width
	
		If( y > height ) Then y = 0
		If( y < 0 ) Then y = height
		
		render()
		
	EndMethod
	
	'*
	'* Rendert das Projektil
	'*
	Method render()
		SetColor_ r, g, b'255,185,15
		DrawRect x-1,y-1,3,3
	End Method
	
	'*
	'* Liefert die zurckgelegte Strecke zurck
	'*
	Method getLength:Int()
		Return Sqr( (oldx-lx)^2 + (oldy-ly)^2 ) 'Sparmanahme: nicht ganz quialent, aber krzer
	EndMethod
	
	'*
	'* Gibt eine Liste an den genutzten Lines zurck
	'*
	Method getLines:TList()
	'	Local l:Line = New Line Sparmanahme: Warum Sachen erstellen, die nicht genutzt werden? + Variablen vermeiden
		Local lines:TList = CreateList_()
		AddFirst_ lines,Line.Create_(x,y,x+dx, y+dy)
		Return lines
	EndMethod
		
End Type


'*
'* AsteroidenForm
'*
Type Oktaeder

	'*    H__A
	'*  G /  \ B
	'*	| . |
	'*  F \__/ C
	'*    E  D

	Field aX#[8], aY#[8] 'Sparmanahme: Nutze Arrays!
	Field angleA[8]
	Field angle#
	Field r,g,b
	Field scale#
	Field x#, y#
	Field pr,pg,pb
	
	Function Create_:Oktaeder( x, y, r, g, b, scale#, angle# )
		
		Local okt:Oktaeder = New Oktaeder
		okt.x = x
		okt.y = y
		okt.r = r
		okt.g = g
		okt.b = b
		okt.pr = 0
		okt.pg = 0
		okt.pb = 0
		okt.scale = scale
		okt.angle = angle		
		
		Local i
		For i=0 To 7
			okt.angleA[i] = Rnd_(0,AsteroidFractal )
			okt.aX[i] = x + Cos_(angle+okt.angleA[i])*scale
			okt.aY[i] = y + Sin_(angle+okt.angleA[i])*scale		
			angle:+45
		Next
		
		Return okt
		
	EndFunction
	
	
	'*
	'* Updatet den Oktaeder
	'*
	Method update(x_,y_,angle_) 'Sparmanahmen: Vermeidung von Self
	
		x = x_
		y = y_
		angle = angle_		
		Local i
		For i=0 To 7
			aX[i] = x + Cos_(angle+angleA[i])*scale
			aY[i] = y + Sin_(angle+angleA[i])*scale				
			angle:+45
		Next
		renderOktaeder()	
	EndMethod
	
	'* 
	'* Gibt den Oktaeder aus
	'*
	Method renderOktaeder()
		SetColor_ pr,pg,pb
		
		DrawPoly getPoints()
		SetColor_ r,g,b
		
		Local i
		For i=0 To 7
			DrawLine_ aX[i], aY[i], aX[(i+1)Mod 8], aY[(i+1)Mod 8]
		Next
	EndMethod
	
	'*
	'* Gibt eine Liste zurck, die alle benutzten Lines beinhaltet
	'*
	Method getLines:TList()
		Local lines:TList = CreateList_()
		Local i
		For i=0 To 7
			AddFirst_ lines,Line.Create_(aX[i], aY[i], aX[(i+1)Mod 8], aY[(i+1)Mod 8])
		Next
		Return lines
	EndMethod
	
	'*
	'* Gibt eine Liste mit den Eckpunkten zurck
	'*
	Method getPoints:Float[]()
		Local points:Float[16]
		Local i
		For i=0 To 7
			points[2*i] = aX[i]
			points[2*i+1] = aY[i]
		Next
		Return points
	EndMethod
	
End Type


' * 
' * TriAngle Object
' *
Type TriAngle
      '*       C 
	'*      / \
	'*     / . \
	'*   A/_ _ _\ B
	'*       

	'* Positions
	Field aX#, aY#, bX#, bY#, cX#, cY#
	Field x#, y#
	
	'* Color
	Field r, g, b
	
	'* Scale
	Field scale# = 1.0
	
	'* Angle
	Field angle#
	
	'* Constructor
	Function Create_:Triangle( x, y, r, g, b, scale#, angle#)
		Local tri:Triangle = New Triangle
		tri.scale = scale		
		'* a
		tri.aX = x - scale*Cos_(angle) + scale*Sin_(angle)
		tri.aY = y - scale*Sin_(angle) - scale*Cos_(angle)				
		'* b
		tri.bX = x + scale*Cos_(angle) + scale*Sin_(angle)
		tri.bY = y + scale*Sin_(angle) - scale*Cos_(angle)		
		'* c 
		tri.cX = x + 2*scale*Cos_(angle+90)
		tri.cY = y + 2*scale*Sin_(angle+90)				
		'* color
		tri.r = r
		tri.g = g
		tri.b = b		
		tri.angle = angle
		tri.x = x
		tri.y = y
		Return tri		
	EndFunction
	
	'*
	'* Updated das Dreieck, passt die Winkel etc an
	'*
	Method update(px, py, pangle#)		
		x = px
		y = py
		angle = pangle	
		'* a
		aX = x - scale*Cos_(angle) + scale*Sin_(angle)
		aY = y - scale*Sin_(angle) - scale*Cos_(angle) 	
		'* b
		bX = x + scale*Cos_(angle) + scale*Sin_(angle)
		bY = y + scale*Sin_(angle) - scale*Cos_(angle) 		
		'* c 
		cX = x + 2*scale*Cos_(angle+90)
		cY = y + 2*scale*Sin_(angle+90)	
	EndMethod
	
	'*
	'* Gibt das Dreieck aus
	'*
	Method RenderTriangle()
		SetColor_ 0,0,0
		DrawPoly getPoints()
		SetColor_ r, g, b
		DrawLine_ ax, ay, bx, by
		DrawLine_ ax, ay, cx, cy
		DrawLine_ bx, by, cx, cy	
	EndMethod
	
	'*
	'* Gibt eine Liste aller Linien aus
	'*
	Method getLines:TList()
		Local l:Line = New Line
		Local lines:TList = CreateList_()
		l = Line.Create_(aX, aY, bX, bY)
		AddFirst_ lines,l
		l = Line.Create_(aX, aY, cX, cY)
		AddFirst_ lines,l
		l = Line.Create_(bX, bY, cX, cY)
		AddFirst_ lines,l
		Return lines
	EndMethod 
	
	'*
	'* Gibt eine Liste mit den Eckpunkten zurck
	'*
	Method getPoints:Float[]()
		Local points:Float[6]
		points[0] = aX
		points[1] = aY
		points[2] = bX
		points[3] = bY
		points[4] = cX
		points[5] = cY
		Return points
	EndMethod
	
End Type


'* 
'* Class Acteur, Base Class of all Objects
'*
Type Acteur	
	Field r, g, b
	Field scale#
	Field angle#
	Field x#, y#
	Field dx#, dy#
	Field speed#	
	'* 
	'* Konstruktor
	'*
	Function Create_:Acteur( x, y, r, g, b, scale, angle# )
		Local act:Acteur = New Acteur	
		act.initActeur(x, y, r, g, b, scale, angle# )	
		Return act
	EndFunction	
	
	'* 
	'* Init Methode
	'*
	Method initActeur( x_, y_, r_, g_, b_, scale_, angle_#  )
		x = x_
		y = y_
		r = r_
		g = g_
		b =b_
		scale = scale_
		angle = angle_
	EndMethod
	
	'*
	'* Updated das Objekt
	'*
	Method update()		
		If( speed >= 0.8 ) 
			speed = 0.8
		EndIf		
		If( x > width ) x = 0
		If( x < 0 ) x = width	
		If( y > height ) y = 0
		If( y < 0 ) y = height		

		If( freezeEnabled = 0 )Then 
			x = x + dx
			y = y + dy
		EndIf
		
		If( speed > 0.1 )
			speed = speed - 0.1
		EndIf	
	EndMethod
End Type 

'*
'* Diese Klasse verwirklicht den Spieler und ist abgeleitet von Acteur
'*
Type Player Extends Acteur
	Field tri:TriAngle
	Field shotTime
	Field enableShot	 
	Field id
	Field vulnerable
	Field enableDoubleShot
	'* 
	'* Konstruktor
	'*
	Function Create_:Player( x, y, r, g, b, scale, angle# )
		Local play:Player = New Player
	
		play.tri = TriAngle.Create_(x,y,r,g,b,scale, angle#)
		play.initActeur(x, y, r, g, b, scale, angle#)
		play.enableShot = True
		play.id = id
		play.vulnerable = 1
		play.enableDoubleShot = 0
		Return play
	EndFunction	
	'*
	'* Updated das Objekt
	'*
	Method update()	
		'* 
		'* Bewegung
		'*
		angle = angle Mod 360		
		If( dx > MaxSpeed# ) dx = MaxSpeed
		If( dx < -MaxSpeed# ) dx = -MaxSpeed
		If( dy > MaxSpeed# ) dy = MaxSpeed
 		If( dy < -MaxSpeed# ) dy = -MaxSpeed	
		Rem
			gigantische Sparmanahme!
			Was fr Unterschiede gibt es zwischen Spieler 1 uns Spieler 2?
			Es sind doch nur die Tasten und die ids, oder?
		EndRem
		Local KEY_TURNLEFT,KEY_TURNRIGHT,KEY_MOVE,KEY_SHOOT
		If id=1
			KEY_TURNLEFT=KEY_LEFT
			KEY_TURNRIGHT=KEY_RIGHT
			KEY_MOVE=KEY_UP
			KEY_SHOOT=KEY_L
		ElseIf id=2
			KEY_TURNLEFT=KEY_A
			KEY_TURNRIGHT=KEY_D
			KEY_MOVE=KEY_W
			KEY_SHOOT=KEY_TAB
		EndIf
		'Spieler x
		If( KeyDown(KEY_TURNLEFT) )
			angle = angle - angleSpeed#
		EndIf	
		If( KeyDown(KEY_TURNRIGHT) )
			angle = angle + angleSpeed#
		EndIf		
		If( KeyDown(KEY_MOVE) ) Then 	
			speed = speed + playerAccelerate#
			dx = dx + Cos_(angle+90)*speed 
			dy = dy + Sin_(angle+90)*speed	
			For i=0 To 2
				par:Projektil = Projektil.Create_(x, y, angle+270+Rnd_(-15,15), 8.0,Rnd_(150,255),Rnd_(0,200),Rnd_(0,50),3) '255,185,15
				AddFirst_ ShipParticles,par
			Next				
		Else
			speed = 0
		EndIf				
		If( KeyHit(KEY_SHOOT) ) Then
			PlaySound sfxShoot
			If( enableDoubleShot = 0 ) Then
				pro:Projektil = Projektil.Create_(x,y,angle+90,2*MaxSpeed,255,185,15,id)
				AddFirst_ Projektile,pro
			Else
				pro:Projektil = Projektil.Create_(x-2*Cos_(angle),y-2*Sin_(angle),angle+85,2*MaxSpeed,255,185,15,id)
				AddFirst_ Projektile,pro
				pro:Projektil = Projektil.Create_(x+2*Cos_(angle),y+2*Sin_(angle),angle+95,2*MaxSpeed,255,185,15,id)
				AddFirst_ Projektile,pro
			EndIf

		EndIf
	
		Super.update()		
		tri.update(x,y, angle)
		tri.RenderTriangle()
		
	EndMethod
End Type


'*
'* Gegner-Model
'*
Type enemyModel	
	Field shuttle:Oktaeder, cockpit:Oktaeder
	Field gun:gunModel
	Field angle#
	Field r,g,b
	Field scale#
	Field x#, y#	
	'*
	'* Konstruktor
	'*
	Function Create_:enemyModel ( x, y, r, g, b, scale#, angle#  )
		
		Local model:enemyModel = New enemyModel
		
		model.x = x
		model.y = y
		model.r = r
		model.g =g
		model.b = b
		model.scale = scale
		model.angle = angle
		
		
		Local oldAsteroidFractal  = AsteroidFractal 
		AsteroidFractal  = 0
		
		model.shuttle = Oktaeder.Create_(x,y,r,g,b,scale, angle)
		model.cockpit = Oktaeder.Create_(x,y,150,150,150,scale/2.5, angle)
		
		AsteroidFractal = oldAsteroidFractal
		
		model.gun = gunModel.Create_( x + Cos_(angle)*scale/2.5,y + Sin_(angle)*scale/2.5, r,g,b,scale, angle )
		
		Return model
		
	EndFunction 
	
	Method update( x_#, y_#, angle_# )
	
		x = x_
		y = y_
		angle = angle_
	
	EndMethod
	
	
	Method render()
		
		shuttle.angle = shuttle.angle + 6
		gun.angle = gun.angle - 2
		
		shuttle.update(x, y, shuttle.angle)
		cockpit.update(x, y, 0)
		gun.update( x + Cos_(gun.angle)*scale/2.5,y + Sin_(gun.angle)*scale/2.5, gun.angle )
	
	EndMethod
	
End Type


'*
'* Kanonen-Model
'*
Type gunModel
	
	Field x#, y#
	Field angle#
	Field r,g,b
	Field scale#
	Field oldScale#
	
	'*
	'* Konstruktor
	'*
	Function Create_:gunModel( x,y,r,g,b,scale, angle )	
		Local model:gunModel = New gunModel		
		model.x = x
		model.y = y
		model.r = r
		model.g =g
		model.b = b
		model.scale = scale
		model.oldScale = scale
		model.angle = angle	
		Return model		
	EndFunction	
	
	'*
	'* Update
	'*
	Method update( x_, y_, angle_ )	
		x = x_
		y = y_
		angle = angle_
		If( scale < oldScale ) scale = scale + 0.5	
		render()	
	EndMethod	
	
	'*
	'* Render
	'*
	Method render()	
		DrawLine_ x, y, x + Cos_(angle)*scale, y + Sin_(angle)*scale	
	EndMethod
	
	
End Type


'*
'* Gegner-Klasse
'*
Type Enemy Extends acteur
	
	Field model:enemyModel
	Field reloadTime
	Field movTime
	Field oldReloadTicks, oldMoveTicks

	Field enableShoot
	
	'*
	'* Konstruktor
	'*
	Function Create_:Enemy( x, y, r, g, b, scale, angle# )	
		Local ene:Enemy = New Enemy		
		ene.initActeur(x, y, r, g, b, scale, angle#)
		ene.speed = Rnd_(1,3)+2
		ene.dx = Cos_(angle)*ene.speed
		ene.dy = Sin_(angle)*ene.speed
		
		ene.model = enemyModel.Create_(x, y, r, g, b, scale, angle)
		
		ene.reloadTime = 1
		ene.movTime = 4	
		
		ene.oldReloadTicks = TimerTicks_(globalTimer)
		ene.oldMoveTicks = TimerTicks_(globalTimer)
		
		ene.enableShoot = 1
		
		Return ene
	EndFunction
	
	'*
	'* Update
	'*
	Method  update()
	
		shoot()
		torkeln()
		
		Super.update()
		model.update(x,y,angle)
		model.render()
		
	EndMethod
	
	'*
	'* Schuss
	'*
	Method shoot()		
		If( enableShoot = 1 ) Then
			If( TimerTicks_(globalTimer) - oldReloadTicks > reloadTime ) Then
				pro:Projektil = Projektil.Create_(x+Cos_(model.gun.angle)*scale,y+Sin_(model.gun.angle)*scale,model.gun.angle,MaxSpeed, 255,185,15,0)
				AddFirst_ Projektile,pro
				oldReloadTicks = TimerTicks_(globalTimer)		
				model.gun.scale =	model.gun.scale*0.5		
			EndIf	
		EndIf		
	EndMethod
	
	'*
	'* Bewegen, aka besoffen durch die Welt torkeln
	'*
	Method torkeln()
		If( TimerTicks_(globalTimer ) - oldMoveTicks > movTime ) Then
		
			angle = Rnd_(0,360)
			speed = Rnd_(1,3)+2
			dx = Cos_(angle)*speed
			dy = Sin_(angle)*speed
				
			oldMoveTicks = TimerTicks_(globalTimer )
		
		EndIf		
	EndMethod
	
End Type


'* 
'* Diese Klasse reprsentiert einen Asteroiden
'*
Type Asteroid Extends Acteur
	Field okta:Oktaeder
	Field life
	
	'* 
	'* Konstruktor
	'*
	Function Create_:Asteroid( x, y, r, g, b, scale, angle#)
		Local ast:Asteroid = New Asteroid
		ast.initActeur(x, y, r, g, b, scale, angle#)
		ast.life = 2
		ast.angle = 0
		ast.okta = Oktaeder.Create_(x,y,r,g,b,scale, angle)
		ast.speed = Rnd_(1,8)
		ast.dx = Cos_(angle)*ast.speed
		ast.dy = Sin_(angle)*ast.speed		
		Return ast
	EndFunction
	
	'*
	'* Updatet den Asteroiden
	'*
	Method update()
		If( freezeEnabled = 0 )Then 
			angle = (angle + 4.0) Mod 360
		EndIf 
		
		If( dx > AsteroidMaxSpeed# ) dx = AsteroidMaxSpeed
		If( dx < -AsteroidMaxSpeed# ) dx = -AsteroidMaxSpeed
		If( dy > AsteroidMaxSpeed# ) dy = AsteroidMaxSpeed
 		If( dy < -AsteroidMaxSpeed# ) dy = -AsteroidMaxSpeed

		Super.update()
		okta.update(x,y,angle)
	EndMethod
	
	'*
	'* Kmmert sich um die "Explosion" eines Asteroiden, spaltet ihn auf etc
	'*
	Method explode()
		If (life > 0) Then
			For i=0 To life 
				Local nr, ng, nb				
					
				ast:Asteroid = Asteroid.Create_(x,y,255,150-(2-life)*50,150-(2-life)*50, scale - (0.3*scale) , angle+Rnd_(0,360) )
				ast.life = life - 1
				AddFirst_ Asteroids,ast
			Next			
		EndIf
		createParticles(x, y,0,360, 5.0,150,255,0,200,0,50, maxParticles) 
	EndMethod
End Type


'*
'* Erstellt Partikel
'*
Function createParticles( x,y,minAngle,maxAngle,speed#,minR,maxR,minG,maxG,minB,maxB, amount )
		For i=0 To amount
			par:Projektil = Projektil.Create_(x,y,Rnd_(minAngle,maxAngle),speed#,Rnd_(minR,maxR),Rnd_(minG,maxG),Rnd_(minB,maxB),3) 
			AddFirst_ Particles,par
		Next
End Function

'*
'* berprft 2 Geraden auf Kollision
'* Parameter: 	1, 2: Punkte der ersten Geraden g
'*            	3, 4: Punkte der ersten Geraden h
'*
Function detectCollision:Int( x1#, y1#, x2#, y2#, x3#, y3#, x4#, y4# )
	
	Local Ubottom# = ((y4 - y3) * (x2 - x1)) - ((x4 - x3) * (y2 - y1)) 'Sparmanahmen: nicht deklarierte Variablen werden nicht gekrzt
   	Local Ua# = 0
   	Local Ub# = 0

   	If (Not (Ubottom = 0) ) Then
      	Ua = (((x4 - x3) * (y1 - y3)) - ((y4 - y3) * (x1 - x3))) / Ubottom
      	Ub = (((x2 - x1) * (y1 - y3)) - ((y2 - y1) * (x1 - x3))) / Ubottom

      	If ((Ua >= 0) And (Ua <= 1) And (Ub >= 0) And (Ub <= 1)) Then
        		x = x1 + (Ua * (x2 - x1))
         		y = y1 + (Ua * (y2 - y1))
         		Return 1
     		EndIf
   	EndIf

   Return 0

EndFunction 

'*
'* Item 
'*
Type Item
	Field name$
	Field r,g,b
	Field symbol$
	Field oldScale#
	Field Scale#
	Field x,y
	Field okta:Oktaeder
	Field active
	Field deleteMe
	Field renderEnabled
	Field startTicks
	Field time
	Function Create_:Item(x,y, name$, symbol$, r, g, b, scale#)
		Local model:Item = New Item
		model.initItem(x,y, name$, symbol$, r, g, b, scale#)		
		Return model		
	EndFunction
	
	Method initItem(x_,y_, name_$, symbol_$, r_, g_, b_, scale_# )
		name = name_
		symbol = symbol_
		r = r_
		g = g_
		b = b_
		scale= scale_
		oldScale = scale_
		x = x_
		y = y_
		Local oldAsteroidFractal  = AsteroidFractal 
		AsteroidFractal  = 0
		okta = Oktaeder.Create_(x,y,r,g,b,scale,0)
		AsteroidFractal = oldAsteroidFractal
		active = 0
		deleteMe = 0
		renderEnabled = 1
		startTicks = TimerTicks_(globalTimer)
		time = 0
	EndMethod
	
	Method render()
		If(renderEnabled = 1) Then
			scale = scale+0.3
			If scale > oldscale+5 Then scale = oldscale
			okta.scale = scale 
			okta.update(x,y,0)
			SetColor_ 200,200,200
			DrawText_ symbol, x-4,y-6
		EndIf
	EndMethod
	
	Method effect(play:Player)
	EndMethod
	
	Method update()
	EndMethod
	
End Type

'*
'* Item: Freeze
'*
Type itemFreeze Extends item
	
	Function Create_:itemFreeze( x,y, name$, symbol$, r, g, b, scale# )
		Local model:itemFreeze= New itemFreeze
		model.initItem(x,y, name$, symbol$, r, g, b, scale#)
		model.time = Rnd_(5,10)
		Return model		
	EndFunction
			
	Method effect(play:Player)
		If( active = 0 And deleteMe = 0) Then 
			startTicks = TimerTicks_(globalTimer)
			freezeEnabled = 1
			active = 1
			renderEnabled = 0
		EndIf
	EndMethod
	
	Method update()
		If(active=1) Then 
			If( startTicks+time < TimerTicks_(globalTimer) ) Then 
				freezeEnabled = 0
				active = 0
				deleteMe = 1
			EndIf
		EndIf
	End Method
	
EndType

'*
'* Item: invulnerable
'*
Type itemInvulnerable Extends item
	
	Function Create_:itemInvulnerable ( x,y, name$, symbol$, r, g, b, scale# )
		Local model:itemInvulnerable = New itemInvulnerable 
		model.initItem( x,y, name$, symbol$, r, g, b, scale# )
		model.time = Rnd_(5,10)
		Return model		
	EndFunction
		
	Method effect(play:Player)	
		If( active = 0 And deleteMe = 0) Then 
			For ply:Player = EachIn Players
				ply.vulnerable = 0
			Next
			active = 1
			renderEnabled = 0
			startTicks = TimerTicks_(globalTimer)
		EndIf		
	EndMethod
	
	Method update()
		If(active=1) Then 
			If( startTicks+time < TimerTicks_(globalTimer) ) Then 
				For ply:Player = EachIn Players
					ply.vulnerable = 1
				Next
				active = 0
				deleteMe = 1
			EndIf
		EndIf
	End Method
	
EndType


'*
'* Item: massDestroy!
'*
Type itemDestroyAll Extends item
	
	Function Create_:itemDestroyAll ( x,y, name$, symbol$, r, g, b, scale# )
		Local model:itemDestroyAll = New itemDestroyAll 
		model.initItem(x,y, name$, symbol$, r, g, b, scale#)
		Return model		
	EndFunction
		
	Method effect(play:Player)	
		If( active = 0 And deleteMe = 0) Then 
		
			For ast:Asteroid = EachIn Asteroids
				ast.life = 0
				ast.explode
				Score = Score + 1	
				If(play.id = 1) Then ScoreP1 = ScoreP1 + 1
				If(play.id = 2) Then ScoreP2 = ScoreP2 + 1
				Asteroids.Remove(ast)
			Next

			For ene:Enemy = EachIn Enemies 
				createParticles(ene.x, ene.y, 0,360, 5.0,150,255,0,200,0,50, maxParticles) 
				Score = Score + 5
				If(play.id = 1) Then ScoreP1 = ScoreP1 + 5
				If(play.id = 2) Then ScoreP2 = ScoreP2 + 5
				Enemies.Remove(ene)
			Next			
			active = 1
			renderEnabled = 0
		EndIf		
	EndMethod
	
	Method update()
		If(active=1) Then 
			active = 0
			deleteMe = 1
		EndIf
	End Method
	
EndType

'*
'* Item: DoppelSchuss
'*
Type itemDoubleShot Extends item
	
	Function Create_:itemDoubleShot ( x,y, name$, symbol$, r, g, b, scale# )
		Local model:itemDoubleShot = New itemDoubleShot 
		model.initItem(x,y, name$, symbol$, r, g, b, scale#)
		model.time = Rnd_(8,15)
		Return model		
	EndFunction
		
	Method effect(play:Player)	
		If( active = 0 And deleteMe = 0) Then 
			For ply:Player = EachIn Players
				ply.enableDoubleShot = 1
			Next
			active = 1
			renderEnabled = 0
			startTicks = TimerTicks_(globalTimer)
		EndIf		
	EndMethod
	
	Method update()
		If(active=1) Then 
			If( startTicks+time < TimerTicks_(globalTimer) ) Then 
				For ply:Player = EachIn Players
					ply.enableDoubleShot = 0
				Next
				active = 0
				deleteMe = 1
			EndIf
		EndIf
	End Method
	
EndType



'*
'* Item: Teammate wiederbeleben
'*
Type itemReviveMate Extends item
	
	Function Create_:itemReviveMate ( x,y, name$, symbol$, r, g, b, scale# )
		Local model:itemReviveMate = New itemReviveMate 
		model.initItem(x,y, name$, symbol$, r, g, b, scale#)
		Return model		
	EndFunction
		
	Method effect(play:Player)	
		If( active = 0 And deleteMe = 0) Then 
			Local temp = 3
			For ply:Player = EachIn Players
				temp = temp - ply.id
			Next
			'* Spieler 2 fehlt
			If( temp = 2 ) Then 
				P1:Player = Player.Create_(WIDTH/2,HEIGHT/2,0,255,0,6.0, 0)
				P1.id = 2
				AddFirst_ Players,P1
			EndIf
			
			'* Spieler 1 fehlt
			If( temp = 1 ) Then 
				P2:Player = Player.Create_(WIDTH/2,HEIGHT/2,0,0,255,6.0, 0)
				P2.id = 1
				AddFirst_ Players,P2
			EndIf
			
			If( temp > 0 ) Then 
				tempItem:itemInvulnerable = itemInvulnerable .Create_(Rnd_(0,WIDTH),Rnd_(0,HEIGHT),"INVULNERABLE","I", 139,28,98,10)
				tempItem.effect(ply)
				AddFirst_ Items,tempItem
			EndIf
			
			active = 1
			renderEnabled = 0
		EndIf		
	EndMethod
	
	Method update()
		If(active=1) Then 
			active = 0
			deleteMe = 1
		EndIf
	End Method
	
EndType


		

'*
'* update World
'*
Function updateWorld:Int()

	For star:Projektil = EachIn Stars
		star.update()
	Next
	
	For ast:Asteroid  = EachIn Asteroids
		ast.update()
	Next	
	
	For pro:Projektil = EachIn Projektile
		pro.update()
		If( pro.getLength() > WIDTH*0.70 ) Projektile.Remove(pro)
	Next
	
	For pro:Projektil = EachIn Projektile

		'* Schuss - Asteroid
		For ast:Asteroid = EachIn Asteroids
			
			If detectShapeCollision( ast.okta.getLines(), pro.getLines() )=1 Then 
				ast.explode()
				Asteroids.Remove(ast)
				Projektile.Remove(pro)
				
				If( pro.id = 1) Then 
					ScoreP1 = ScoreP1 + 1	
					Score = Score + 1
				EndIf
				
				If( pro.id = 2) Then 
					ScoreP2 = ScoreP2 + 1	
					Score = Score + 1
				EndIf
				
				PlaySound TSound(sfxExplode.valueAtIndex(Rnd_(0,MaxExplodeSounds )))			
			EndIf 
			
		Next
		
		'* Schuss - Spieler
		For ply:Player = EachIn Players
			If detectShapeCollision( ply.tri.getLines(), pro.getLines() )=1 And ply.vulnerable = 1 Then 
			
				If( pro.id = 0 ) Then
				
					createParticles(ply.x, ply.y, 0,360, 5.0,150,255,0,200,0,50, maxParticles)				
					PlaySound sfxHit 
					Players.Remove(ply)
					Projektile.Remove(pro)	
					PlaySound TSound(sfxExplode.valueAtIndex(Rnd_(0,MaxExplodeSounds )))			
				EndIf

			EndIf 			
		Next	
		
		
		For ene:Enemy = EachIn Enemies
			'* Schuss - Gegner
			If detectShapeCollision( ene.model.shuttle.getLines(), pro.getLines() )=1 Then 
				
				createParticles(ene.x, ene.y, 0,360, 5.0,150,255,0,200,0,50, maxParticles) 
				Enemies.Remove(ene)
				Projektile.Remove(pro)	
				
				If( pro.id = 1) Then 
					ScoreP1 = ScoreP1 + 10	
					score = score + 10	
				EndIf
				
				If( pro.id = 2) Then 
					ScoreP2 = ScoreP2 + 10	
					score = score + 10	
				EndIf			
				
				PlaySound TSound(sfxExplode.valueAtIndex(Rnd_(0,MaxExplodeSounds )))	
			EndIf 			
		Next	
		
	Next
	
	'*Gegner - Asteroid
	For ene:Enemy = EachIn Enemies	
		For ast:Asteroid = EachIn Asteroids
			If( detectShapeCollision(ene.model.shuttle.getLines(), ast.okta.getLines()) )=1 Then
				createParticles(ene.x, ene.y, 0,360, 5.0,150,255,0,200,0,50, maxParticles) 
				Enemies.Remove(ene)
				PlaySound TSound(sfxExplode.valueAtIndex(Rnd_(0,MaxExplodeSounds )))	
			EndIf
		Next
	Next
	
	For ene:Enemy = EachIn Enemies
		ene.update()
	Next
	
	For ply:Player = EachIn Players
		
		Local oldFreezeEnabled = freezeEnabled	
		freezeEnabled = 0
		ply.update()
		freezeEnabled = oldFreezeEnabled 
		
		'*Spieler - Asteroid
		For ast:Asteroid = EachIn Asteroids
			If detectShapeCollision( ast.okta.getLines(), ply.tri.getLines() )=1 And ply.vulnerable = 1 Then 
				createParticles(ply.x, ply.y, 0,360, 5.0,150,255,0,200,0,50, maxParticles)
				Players.Remove(ply)
				PlaySound TSound(sfxExplode.valueAtIndex(Rnd_(0,MaxExplodeSounds )))	
			EndIf 
			
		Next
		
		For ene:Enemy = EachIn Enemies
			'* Gegner - Spieler
			If detectShapeCollision( ene.model.shuttle.getLines(), ply.tri.getLines() ) = 1 And ply.vulnerable = 1 Then
				createParticles(ply.x, ply.y, 0,360, 5.0,150,255,0,200,0,50, maxParticles)
				Players.Remove(ply)
				PlaySound TSound(sfxExplode.valueAtIndex(Rnd_(0,MaxExplodeSounds )))	
			EndIf
		Next
		
		'* Spieler - Item
		For it:Item = EachIn Items
			
			If detectShapeCollision( it.okta.getLines(), ply.tri.getLines() ) = 1 Then 
				it.effect(ply)
				PlaySound sfxItem 
			EndIf
			
		Next

	Next		
	
	For par:Projektil = EachIn Particles
		par.update()
		If( par.getLength() > 75 ) Particles.Remove(par)
	Next
	
	For par:Projektil = EachIn ShipParticles
		par.update()
		If( par.getLength() > 40 ) ShipParticles.Remove(par)
	Next
	
	Local amountOfActiveItems = 0
	For it:Item = EachIn Items
		it.render()
		it.update()
		
		DrawText_ "Item enabled: ",WIDTH/2-150, 10
		If(it.renderEnabled = 0) Then
			SetColor_ 0,255,0
			 DrawText_ it.name +" !!!"+ ": "+(it.time-(TimerTicks_(globalTimer)-it.startTicks)+1), WIDTH/2, 10+ amountOfActiveItems*20
			amountOfActiveItems = amountOfActiveItems +1
		EndIf 
			
		If( it.deleteMe = 1 ) Then Items.Remove(it)
	Next
		
EndFunction


'*
'* Detect Collision between an Enemy and an Asteroid
'*
Function detectCollideEnemyAst:Int( ene:Enemy, ast:Asteroid )
	Return detectOvalCollision( ene.x-ene.scale, ene.y-ene.scale, ast.x-ast.scale, ast.y-ast.scale, ast.scale )
EndFunction


'*
'* Detect Collision betweeen 2 Rects
'*
Function detectOvalCollision:Int( x1, y1, x2, y2, r# )	
	If( Sqr((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1) ) < r# ) Return 1
	Return 0
EndFunction 

'*
'* Detect Collision between 2 Shapes, defined by lines
'*
Function detectShapeCollision:Int( s1:TList, s2:TList )
	For l1:Line = EachIn s1
		For l2:Line = EachIn s2
			If( detectCollision( l1.x1, l1.y1, l1.x2, l1.y2, l2.x1, l2.y1, l2.x2, l2.y2 ) ) Return 1
		Next
	Next
	Return 0
EndFunction


'* Some Game Setup

Graphics width, height, 0, 32
Global angleSpeed# = 9.0
Global playerAccelerate# = 0.11
Global MaxSpeed# = 10.0
Global AsteroidFractal = 50
Global AsteroidMaxSpeed# = 5

Global Asteroids:TList = CreateList_()
Global Projektile:TList = CreateList_()
Global OktaederLines:TList = CreateList_()
Global Players:TList = CreateList_() 
Global Enemies:TList = CreateList_()
Global Particles:TList = CreateList_()
Global ShipParticles:TList = CreateList_()
Global Items:TList = CreateList_()


Global Score = 0
Global scoreP1 = 0
Global scoreP2 = 0

Global oldItemTTicks = 0
Global ItemReloadTime = 5

Global oldAsteroidTTicks = 0
Global AsteroidReloadTime = 3

Global oldEnemyTTicks = 0
Global EnemyReloadTime = 4

'Global globalTimer = New TTimer Sparmanahmen: unntiger Timer
'globalTimer = CreateTimer(1)'Sparmanahmen
Global globalTimer=CreateTimer(1)

Global safetyRange = 200
Global maxParticles = 10

Global difficultyUpTime = 30
Global oldDifficultyUpTime = 0

Global stars:TList = CreateList_()

Global freezeEnabled = 0




'*
'* Erstellt gewnschte Anzahl an Asteroiden
'*
Function createAsteroids( amount )

	Local temp = amount
	
	While( temp > 0 )

		Local x,y
		Local collide = 0
		Local scale = Rnd_(0,1)*20+30.0	'Sparmanahme: Ich hoffe, dass dies hier nichts nderte			
	
		x = Rnd_(0,WIDTH)
		y = Rnd_(0,HEIGHT)
	

		For ply:Player = EachIn Players
			If( detectOvalCollision( x, y, ply.x, ply.y, safetyRange )=1 ) collide = 1			
		Next

		If( collide = 0 )
			ast:Asteroid = Asteroid.Create_(x,y,139,35,35, scale, Rnd_(0,360) )
			AddFirst_ Asteroids,ast
			temp = temp - 1
		EndIf
	
	Wend

EndFunction


'*
'* Erstellt gewnschte Anzahl an Enemies
'*
Function createEnemies( amount )

	Local temp = amount
	
	While( temp > 0 )

		Local x,y
		Local collide = 0
		Local scale = Rnd_(0,1)*20+30.0				
	
		x = Rnd_(0,WIDTH)
		y = Rnd_(0,HEIGHT)
	

		For ply:Player = EachIn Players
			If( detectOvalCollision( x, y, ply.x, ply.y, safetyRange )=1 ) collide = 1			
		Next

		If( collide = 0 )
			ene:Enemy = Enemy.Create_(x,y,102,205,0, 18.0, Rnd_(0,360) )
			AddFirst_ Enemies,ene
			temp = temp - 1
		EndIf
	
	Wend

EndFunction

'*
'* Lscht alle Objekte im Spiel
'*
Function resetWorld()
	Asteroids:TList = CreateList_()
	Projektile:TList = CreateList_()
	OktaederLines:TList = CreateList_()
	Players:TList = CreateList_() 
	Enemies:TList = CreateList_()
	Particles:TList = CreateList_()
	ShipParticles:TList = CreateList_()
	stars:TList = CreateList_()
	Items:TList = CreateList_()
	Score = 0
	ScoreP1 = 0
	ScoreP2 = 0
	
	oldItemTTicks = 0
	ItemReloadTime = 5

	oldAsteroidTTicks = 0
	AsteroidReloadTime = 3

	oldEnemyTTicks = 0
	EnemyReloadTime = 4

	'globalTimer = New TTimer Sparmanahme: unntiges Erstellen eines Timers?
	globalTimer = CreateTimer(1)

	safetyRange = 200
	maxParticles = 10

	difficultyUpTime = 30
	oldDifficultyUpTime = 0
	
	freezeEnabled = 0
EndFunction

'*
'* Initialisiert die Welt
'*
Function initWorld()
		
	P1:Player = Player.Create_(WIDTH/2,HEIGHT/2,0,0,255,6.0, 0)
	P1.id = 1
	P1.vulnerable = 1
	AddFirst_ Players,P1
	
	P2:Player = Player.Create_(WIDTH/2+40,HEIGHT/2+40,0,255,0,6.0, 0)
	P2.id = 2
	P2.vulnerable = 1
	AddFirst_ Players,P2
	
	createAsteroids(1)
	
	oldAsteroidTTicks = TimerTicks_(globalTimer )
	oldEnemyTTicks = TimerTicks_(globalTimer )
	oldDifficultyUpTime = TimerTicks_(globalTimer )
	
	AsteroidReloadTime = 3
	EnemyReloadTime = 4

	score = 0
	
	For i=0 To 100
		star:Projektil = Projektil.Create_(Rnd_(0,WIDTH),Rnd_(0,HEIGHT),Rnd_(0,360),0,100,100,100,3)
		AddFirst_ stars,star
	Next
	
EndFunction


' *
' * Game-Loop
' *   
initWorld()

While Not KeyHit( KEY_ESCAPE )

	Cls 
		
	'*Every few Seconds a new Asteroid...
	If( TimerTicks_(globalTimer) - oldAsteroidTTicks > AsteroidReloadTime  ) Then
		createAsteroids(1)
		oldAsteroidTTicks = TimerTicks_(globalTimer )				
	EndIf
		
	'*Every few Seconds a new Enemy...
	If( (TimerTicks_(globalTimer ) - oldEnemyTTicks) > EnemyReloadTime  ) Then
		createEnemies(1)
		oldEnemyTTicks = TimerTicks_(globalTimer )
	EndIf
 
	'*Every x seconds, a little more speed...
	If( (TimerTicks_(globalTimer ) - oldDifficultyUpTime ) > DifficultyUpTime ) Then
		SetColor_ 255, 0, 0
		If(AsteroidReloadTime > 1) Then AsteroidReloadTime = AsteroidReloadTime - 1 
		If(EnemyReloadTime > 1) Then EnemyReloadTime = EnemyReloadTime  - 1
		oldDifficultyUpTime = TimerTicks_(globalTimer )
		
	EndIf
	
	'*Every few seconds a new Item
	If( (TimerTicks_(globalTimer ) - oldItemTTicks ) > ItemReloadTime ) Then
		Local temp = Rnd_(0,5),itemx:item 'Sparmanahmen
		Select temp
			'Hier gibt es eine nderung: Die Variablen wurden nur hier genutzt.
			Case 0
				itemx = ItemFreeze.Create_(Rnd_(0,WIDTH),Rnd_(0,HEIGHT),"FREEZE","F", 84,139,84,10)
			Case 1
				itemx= itemInvulnerable .Create_(Rnd_(0,WIDTH),Rnd_(0,HEIGHT),"INVULNERABLE","I", 139,28,98,10)
			Case 2
				itemx= itemDestroyAll .Create_(Rnd_(0,WIDTH),Rnd_(0,HEIGHT),"DESTROY!","D", 199,21,133,10)
			Case 3
				itemx= itemDoubleShot .Create_(Rnd_(0,WIDTH),Rnd_(0,HEIGHT),"DoubleShot!","2", 255,165,0,10)
			Case 4
				itemx= itemReviveMate .Create_(Rnd_(0,WIDTH),Rnd_(0,HEIGHT),"REVIVED Teammate!","R", 255,165,0,10)
			Default
		
		End Select 			
		If itemx AddFirst_ items,itemx
		oldItemTTicks = TimerTicks_(globalTimer)
		
	EndIf
	
	'*Some Debug Output
	
	'*Update World
	updateWorld()
	
	'* Display Score
	SetColor_ 200,200,200
	DrawText_ "Score: "+Score, 0,0
	
	SetColor_ 0,0,255
	DrawText_ "Score P1: "+ScoreP1, 0,20

	SetColor_ 0,255,0
	DrawText_ "Score P2: "+ScoreP2, 0,40
	
	SetColor_ 200,200,200
	DrawText_ "Time: "+TimerTicks_(globalTimer)+"s",0,60

	
	
	'* Game Over
	If( Players.isEmpty() ) Then
		Local reachedTime = TimerTicks_(globalTimer)
		Local enter = 0
		While( Not KeyHit(KEY_ESCAPE) And enter = 0)
			Cls 
			updateWorld()
			
			SetColor_ 255,255,255
			DrawText_ "GAME OVER!", (WIDTH/2)-60, HEIGHT/2
			SetColor_ 0,0,255
			DrawText_ "Score P1: "+ScoreP1, (WIDTH/2)-70, HEIGHT/2+20
			SetColor_ 0,255,0
			DrawText_ "Score P2: "+ScoreP2, (WIDTH/2)-70, HEIGHT/2+40
			SetColor_ 255,255,255
			DrawText_ "Overall Score: "+score, (WIDTH/2)-70, HEIGHT/2+60
			DrawText_ "Durchgehaltene Zeit: "+reachedTime +"s", (WIDTH/2)-110, HEIGHT/2+80
			DrawText_ "Druecke ENTER fuer noch ein Spiel, oder verlasse mit ESC", (WIDTH/2)-230, HEIGHT/2+100
			
			If( KeyHit(KEY_ENTER) ) Then
				enter = 1	
				resetWorld()		
				initWorld()				
			EndIf
			Flip
		Wend
		
		If( enter = 0) Then Return
	EndIf
	Flip

Wend



Function LoadSound_:TSound(a:Object) '+-0
	Return LoadSound(a)
EndFunction
Function AddFirst_(a:TList,b:Object)
	a.AddFirst b
EndFunction
Function CreateList_:TList()
	Return New TList
EndFunction
Function Rnd_!(a!,b!)
	Return Rnd(a,b)
EndFunction
Function DrawText_(a$,b#,c#)
	DrawText a,b,c
EndFunction
Function SetColor_(a,b,c)
	SetColor a,b,c
EndFunction
Function DrawLine_(a#,b#,c#,d#)
	DrawLine a,b,c,d
EndFunction
Function Sin_!(a!)
	Return Sin(a)
EndFunction
Function Cos_!(a!)
	Return Cos(a)
EndFunction
Function TimerTicks_(a:TTimer)
	Return TimerTicks(a)
EndFunction
